/*
 * *********************************************************
 * Copyright (c) 2009 - 2014, DHBW Mannheim - Tigers Mannheim
 * Project: TIGERS - Sumatra
 * Date: Jul 14, 2014
 * Author(s): lukas
 * *********************************************************
 */
package edu.dhbw.mannheim.tigers.sumatra.model.modules.impls.autoreferee;

import edu.dhbw.mannheim.tigers.sumatra.model.data.frames.AIInfoFrame;
import edu.dhbw.mannheim.tigers.sumatra.model.data.shapes.vector.IVector2;
import edu.dhbw.mannheim.tigers.sumatra.model.modules.impls.ai.config.AIConfig;
import edu.dhbw.mannheim.tigers.sumatra.model.modules.impls.autoreferee.RefereeCaseMsg.EMsgType;


/**
 * TODO lukas, add comment!
 * - What should this type do (in one sentence)?
 * - If not intuitive: A simple example how to use this class
 * 
 * @author lukas
 */
public class OutOfBoundsCase extends ARefereeCase
{
	
	// --------------------------------------------------------------------------
	// --- variables and constants ----------------------------------------------
	// --------------------------------------------------------------------------
	
	
	// --------------------------------------------------------------------------
	// --- constructors ---------------------------------------------------------
	// --------------------------------------------------------------------------
	/**
	 * 
	 */
	public OutOfBoundsCase()
	{
		
	}
	
	
	// --------------------------------------------------------------------------
	// --- methods --------------------------------------------------------------
	// --------------------------------------------------------------------------
	@Override
	protected RefereeCaseMsg checkCase(final AIInfoFrame frame)
	{
		IVector2 ballPos = frame.getWorldFrame().getBall().getPos();
		if (!AIConfig.getGeometry().getField().isPointInShape(ballPos))
		{
			if (Math.abs(ballPos.y()) < (AIConfig.getGeometry().getGoalSize() / 2))
			{
				// The ball is inside the goal
				return null;
			}
			return new RefereeCaseMsg(frame.getTacticalField().getBotLastTouchedBall().getTeamColor(),
					EMsgType.OUT_OF_BOUNDS);
		}
		return null;
	}
	// --------------------------------------------------------------------------
	// --- getter/setter --------------------------------------------------------
	// --------------------------------------------------------------------------
}
