/*
 * *********************************************************
 * Copyright (c) 2009 - 2012, DHBW Mannheim - Tigers Mannheim
 * Project: TIGERS - Sumatra
 * Date: 28.04.2012
 * Author(s): Manuel
 * 
 * *********************************************************
 */
package edu.dhbw.mannheim.tigers.shared;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * TODO Manuel, add comment! - What should this type do (in one sentence)? - If
 * not intuitive: A simple example how to use this class
 * 
 * @author Manuel
 * 
 */
public class AndroidMessage implements Serializable {
	// --------------------------------------------------------------------------
	// --- variables and constants
	// ----------------------------------------------
	// --------------------------------------------------------------------------
	private static final long serialVersionUID = -4183364511393852246L;

	// type of the command --> from android or to android
	private EAndroidMessageType eAndroidMessageType;

	// commands from android device to server
	private AndroidBot androidBot;
	private AndroidCommand androidCommand;

	// commands from server to android device
	private ArrayList<AndroidBot> activeBotlist;

	// --------------------------------------------------------------------------
	// --- constructors
	// ---------------------------------------------------------
	// --------------------------------------------------------------------------
	public AndroidMessage(EAndroidMessageType eAndroidMessageType) {
		this.eAndroidMessageType = eAndroidMessageType;
	}
	
	public AndroidMessage(AndroidMessage msg) 
	{
		this.eAndroidMessageType = msg.eAndroidMessageType;
		this.activeBotlist = msg.activeBotlist;
		this.androidBot = msg.androidBot;
		this.androidCommand = msg.androidCommand;
	}

	// --------------------------------------------------------------------------
	// --- methods
	// --------------------------------------------------------------
	// --------------------------------------------------------------------------
	public void resetAndroidMessage() {
		this.androidCommand = null;
		this.activeBotlist = null;
		this.androidBot = null;
	}

	// --------------------------------------------------------------------------
	// --- getter/setter
	// --------------------------------------------------------
	// --------------------------------------------------------------------------
	/**
	 * @return the type of the message
	 */
	public EAndroidMessageType getEAndroidMessageType() {
		return eAndroidMessageType;
	}

	/**
	 * @param eAndroidMessageType
	 *            - the type of the message
	 */
	public void setEAndroidMessageType(EAndroidMessageType eAndroidMessageType) {
		this.eAndroidMessageType = eAndroidMessageType;
	}

	/**
	 * @return the androidBot
	 */
	public AndroidBot getAndroidBot() {
		return androidBot;
	}

	/**
	 * @param androidBot
	 *            the androidBot to set
	 */
	public void setAndroidBot(AndroidBot androidBot) {
		this.androidBot = androidBot;
	}

	/**
	 * @return the androidCommand
	 */
	public AndroidCommand getAndroidCommand() {
		return androidCommand;
	}

	/**
	 * @param androidCommand
	 *            the androidCommand to set
	 */
	public void setAndroidCommand(AndroidCommand androidCommand) {
		this.androidCommand = androidCommand;
	}

	/**
	 * @return the activeBotlist
	 */
	public ArrayList<AndroidBot> getActiveBotlist() {
		return activeBotlist;
	}

	/**
	 * @param activeBotlist
	 *            the activeBotlist to set
	 */
	public void setActiveBotlist(List<AndroidBot> activeBotlist) {
		if (this.activeBotlist == null) {
			this.activeBotlist = new ArrayList<AndroidBot>();
		}
		this.activeBotlist.removeAll(this.activeBotlist);
		this.activeBotlist.addAll(activeBotlist);
	}
}